#  This program may be used, executed, copied, modified and distributed
#  without royalty for the purpose of developing, using, marketing, or distributing.
#
# script for creating XD default template
#
# author: bkmartin

import sys
import java

nl = java.lang.System.getProperty("line.separator")
endpoints = []
serverEntryTemplates = []
hostName = "*"

def createEndPoint(serverTemplate, endPointName, endPointHost, endPointPort):
    print "Creating new End Point"
    attrs = []
    namedEndpointAttrs = ["endPointName", endPointName]
    attrs.append(namedEndpointAttrs)
    namedEndPoint = AdminConfig.create("NamedEndPoint", serverTemplate, attrs)
    attrs = []
    hostAttr = ["host", endPointHost]
    portAttr = ["port", endPointPort]
    attrs.append(hostAttr)
    attrs.append(portAttr)
    try:
       newEndPoint = AdminConfig.create("EndPoint", namedEndPoint, attrs)
       print "Successfully created new end point"
    except:
       print "Exception while creating new end point"
           

def convertToList(inlist):
     outlist=[]
     if (len(inlist)>0 and inlist[0]=='[' and inlist[len(inlist)-1]==']'):
        inlist = inlist[1:len(inlist)-1]
        clist = inlist.split(" ")
     else:
        clist = inlist.split("\n")
     for elem in clist:
        elem=elem.rstrip();
        if (len(elem)>0):
           outlist.append(elem)
     return outlist

def getConfigIdForTemplate(templateName):
   templates=convertToList(AdminConfig.listTemplates("Server"))
   for template in templates:
       cname = AdminConfig.showAttribute(template,"name")
       if (cname == templateName):
          return template
   return None
   
def getServerType(serverTemplate):
    tokens = serverTemplate.split("/")
    idx = 0
    for token in tokens:
#      serverTemplate is of the form 'defaultXD(templates/servertypes/APPLICATION_SERVER/servers/defaultXD|server.xml#Server_1210548827522)'
#      return third token 
       if (idx == 2): 
         return token
       idx=idx+1
    return None

#
# main program
#
is64BitJvm = "false"
if (len(sys.argv) > 0):
  for arg in sys.argv:
    if (arg.startswith("-is64BitJvm:")):
      parts = arg.split(":")
      if (parts[1] == "true"):
        is64BitJvm = parts[1]


print "creating XD template"
template=getConfigIdForTemplate("defaultXD")
if (template == None):
   AdminTask.createTemplateFromTemplate('[-sourceTemplate default -destinationTemplate defaultXD -description "WebSphere Intelligent Management Default Template"]')
   template=getConfigIdForTemplate("defaultXD")
   threadpools=convertToList(AdminConfig.list("ThreadPool",template))
   for threadpool in threadpools:
      tname = AdminConfig.showAttribute(threadpool,"name")
      if (tname == "WebContainer"):
         print "modifying WebContainer threadpool in xd template"
         AdminConfig.modify(threadpool,[['maximumSize','175']])

   transportchannels=convertToList(AdminConfig.list("TransportChannelService",template))
   for transportchannel in  transportchannels:
       tsname = AdminConfig.showAttribute(transportchannel,"transportChannels")
       transportchannels = tsname[1:len(tsname)-1].split(" ")
       for transportchannel in transportchannels:
          allAttributes = AdminConfig.showall(transportchannel).split("\n")
          found = 0
          for attrib in allAttributes:
            str = attrib.replace('[','' ).replace(']','').split('\r\n')
            value = str[0].split()
            if (value[0] == 'maximumPersistentRequests'):
                  print "maximumPersistentRequests found = true "
                  found = 1
                  break

          if (found == 1):
             print "modifying the transportchannel"
             AdminConfig.modify(transportchannel, [['maximumPersistentRequests', '-1']])

else:
   print "template already created"


print "creating XD ZOS template"
template=getConfigIdForTemplate("defaultXDZOS")
if (template == None):
   AdminTask.createTemplateFromTemplate('[-sourceTemplate defaultZOS -destinationTemplate defaultXDZOS -description "WebSphere XD ZOS Default Template"]')
   template=getConfigIdForTemplate("defaultXDZOS")
   threadpools=convertToList(AdminConfig.list("ThreadPool",template))
   for threadpool in threadpools:
      tname = AdminConfig.showAttribute(threadpool,"name")
      if (tname == "WebContainer"):
         print "modifying WebContainer threadpool in xd zOS template"
         AdminConfig.modify(threadpool,[['maximumSize','175']])

   transportchannels=convertToList(AdminConfig.list("TransportChannelService",template))
   for transportchannel in  transportchannels:
       tsname = AdminConfig.showAttribute(transportchannel,"transportChannels")
       transportchannels = tsname[1:len(tsname)-1].split(" ")
       for transportchannel in transportchannels:
          allAttributes = AdminConfig.showall(transportchannel).split("\n")
          found = 0
          for attrib in allAttributes:
            str = attrib.replace('[','' ).replace(']','').split('\r\n')
            value = str[0].split()
            if (value[0] == 'maximumPersistentRequests'):
                  print "maximumPersistentRequests found = true "
                  found = 1
                  break

          if (found == 1):
             print "modifying the transportchannel"
             AdminConfig.modify(transportchannel, [['maximumPersistentRequests', '-1']])
else:
   print "template already created"

print "Add generic JVM argument '-agentlib:HeapDefect' to application server defaultXD/defaultXDZOS templates and ODR templates"
serverTemplates = convertToList(AdminConfig.listTemplates("Server"))
for serverTemplate in serverTemplates:
    serverType = getServerType(serverTemplate)
    serverTemplateName = AdminConfig.showAttribute(serverTemplate,"name")
    if ((serverType == "APPLICATION_SERVER" and (serverTemplateName == "defaultXD" or serverTemplateName == "defaultXDZOS")) or
        (serverType == "ONDEMAND_ROUTER")):
       procDefs = convertToList(AdminConfig.showAttribute(serverTemplate, "processDefinitions"))
       for procDef in procDefs:
           if (procDef.find("JavaProcessDef") != -1):
              jvmEntries = AdminConfig.showAttribute(procDef, "jvmEntries")
              if (len(jvmEntries)>0 and jvmEntries[0]=='[' and jvmEntries[len(jvmEntries)-1]==']'):
              	  jvmEntries = jvmEntries[1:len(jvmEntries)-1]
              genericArgs = AdminConfig.showAttribute(jvmEntries, "genericJvmArguments")
              if (is64BitJvm == "true"):
                if (genericArgs.find("-agentlib:HeapDetect64") == -1):
                   genericArgs = "-agentlib:HeapDetect64 " + genericArgs
                   AdminConfig.modify(jvmEntries, [["genericJvmArguments", genericArgs]])
              else:
                if (genericArgs.find("-agentlib:HeapDetect") == -1):
                   genericArgs = "-agentlib:HeapDetect " + genericArgs
                   AdminConfig.modify(jvmEntries, [["genericJvmArguments", genericArgs]])
       
print "saving workspace"
AdminConfig.save()
print "finished."

